#lang racket

;; Instead of encoding deposit versus balance in
;;  the message, encode it in the choice of
;;  channel, which is more general (and, yes, tends
;;  to fit type systems better).

(define deposit-ch (make-channel))
(define balance-ch (make-channel))

(define (serve balance)
  (define req (sync deposit-ch
                    balance-ch))
  (if (number? req)
      (serve (+ balance req))
      (begin
        (channel-put req balance)
        (serve balance))))

(thread (lambda () (serve 0)))

(channel-put deposit-ch 10)

(define reply-ch (make-channel))
(channel-put balance-ch reply-ch)
(channel-get reply-ch)
